﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TechNote63_ImageViewer_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private bool m_bClick;
        private bool m_bFirst;
        private string m_strSearchWord;
        private int m_iClickX;
        private int m_iSelectMemory;
        private SmartX.SmartFile.SEARCHFILEINFOS[] m_sFoundFileList;

        private void Form1_Load(object sender, EventArgs e)
        {
            smartForm1.MainForm = this;
            smartForm1.AddChildForm(smartInnerForm1);
            smartForm1.AddChildForm(smartInnerForm2);
            smartForm1.Show(0);
        }

        private void btnFlashDisk_Click(object sender, EventArgs e)
        {
            m_iSelectMemory = 0;
            DeviceSelect(m_iSelectMemory);
        }

        private void btnHardDisk_Click(object sender, EventArgs e)
        {
            m_iSelectMemory = 1;
            DeviceSelect(m_iSelectMemory);
        }

        private void btnSDCard_Click(object sender, EventArgs e)
        {
            m_iSelectMemory = 2;
            DeviceSelect(m_iSelectMemory);
        }

        private void btnAll_Click(object sender, EventArgs e)
        {
            m_iSelectMemory = 3;
            DeviceSelect(m_iSelectMemory);
        }
        
        // Item을 더블클릭하여 선택
        private void lstImageList_DoubleClick(object sender, EventArgs e)
        {
            // 선택된 항목이 있는지 확인
            if (lstImageList.SelectItemIndex == -1)
            {
                SmartX.SmartMessageBox.Show("선택한 이미지가 없습니다.");
                return;
            }

            smartPictureBox1.ImageListClear();

            for (int i = 0; i < lstImageList.ItemCount; i++)
            {
                smartPictureBox1.AddImageList(lstImageList.Items[i].Trim());
            }

            smartForm1.Show(2);

            smartPictureBox1.DrawNext(lstImageList.SelectItemIndex);
        }

        private void btnScrollButton_Click(object sender, EventArgs e)
        {
            if (sender == btnScrollUp)
            {
                lstImageList.ScrollUp();
            }
            else
            {
                lstImageList.ScrollDown();
            }
        }

        private void btnBack_Click(object sender, EventArgs e)
        {
            lstImageList.ClearAll();
            smartForm1.Show(0);
        }

        private void btnSearch_Click(object sender, EventArgs e)
        {
            DeviceSelect(m_iSelectMemory);
        }

        private void smartPictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            m_bClick = false;
            // 클릭 지점의 x좌표값 저장
            m_iClickX = e.X;
        }

        private void smartPictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            m_bClick = true;
            m_bFirst = true;
            smartTimer1.Start();
        }

        private void smartTimer1_Tick(object sender, EventArgs e)
        {
            // 처음 눌러진게 아닌 경우.
            if (m_bFirst == false)
            {
                smartTimer1.Stop();
                // 누른 상태인 경우
                if (m_bClick == true)
                {
                    DialogResult eDialogResult = SmartX.SmartMessageBox.Show("Exit?", "화면보기", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                    // Yes를 누른 경우
                    if (eDialogResult == DialogResult.Yes)
                    {
                        smartForm1.Show(1);
                    }
                }
                m_bFirst = true;
                return;
            }
            m_bFirst = !m_bFirst;
        }

        private void smartPictureBox1_DoubleClick(object sender, EventArgs e)
        {
            // 화면 좌측 클릭
            if (m_iClickX < 400)
            {
                smartPictureBox1.IncrementType = SmartX.SmartPictureBox.IncrementTypes.Decrement;
                smartPictureBox1.DrawNext();
            }
            else
            {
                smartPictureBox1.IncrementType = SmartX.SmartPictureBox.IncrementTypes.Increment;
                smartPictureBox1.DrawNext();
            }
        }

        private void smartCheckBox_Click(object sender, EventArgs e)
        {
            if (sender == chkAll)
            {
                chkBmp.Checked = false;
                chkGif.Checked = false;
                chkJpg.Checked = false;
                chkPng.Checked = false;
                chkTif.Checked = false;
            }
            else
            {
                chkAll.Checked = false;
            }
        }

        // 전체 목록 출력
        private void DeviceSelect(int iSelectMemory)
        {
            smartForm1.Show(1);

            // 현재 경로의 파일 리스트를 얻습니다.
            // 리스트 항목 모두 삭제
            lstImageList.ClearAll();

            if (chkAll.Checked == true)
            {
                m_strSearchWord = "*.bmp;*.jpg;*.png;*.tif;*.gif;";
            }
            else if (chkBmp.Checked == true)
            {
                m_strSearchWord = "*.bmp";
            }
            else if (chkJpg.Checked == true)
            {
                m_strSearchWord = "*.jpg";
            }
            else if (chkPng.Checked == true)
            {
                m_strSearchWord = "*.png";
            }
            else if (chkTif.Checked == true)
            {
                m_strSearchWord = "*.tif";
            }
            else if (chkGif.Checked == true)
            {
                m_strSearchWord = "*.gif";
            }
            else
            {
                SmartX.SmartMessageBox.Show("최소 하나 이상 선택이 필요합니다.");
            }

            switch (iSelectMemory)
            {
                case 0:
                    m_sFoundFileList = SmartX.SmartFile.FileSearch("Flash Disk", m_strSearchWord, chkSubDir.Checked);
                    for (int i = 0; i < m_sFoundFileList.Length; i++)
                    {
                        SmartListBoxAddItem(i);
                    }
                    break;
                case 1:
                    m_sFoundFileList = SmartX.SmartFile.FileSearch("하드 디스크", m_strSearchWord, chkSubDir.Checked);
                    for (int i = 0; i < m_sFoundFileList.Length; i++)
                    {
                        SmartListBoxAddItem(i);
                    }
                    break;
                case 2:
                    m_sFoundFileList = SmartX.SmartFile.FileSearch("SD Card", m_strSearchWord, chkSubDir.Checked);
                    for (int i = 0; i < m_sFoundFileList.Length; i++)
                    {
                        SmartListBoxAddItem(i);
                    }
                    break;
                case 3:
                    m_sFoundFileList = SmartX.SmartFile.FileSearch("Flash Disk", m_strSearchWord, chkSubDir.Checked);
                    for (int i = 0; i < m_sFoundFileList.Length; i++)
                    {
                        SmartListBoxAddItem(i);
                    }
                    m_sFoundFileList = SmartX.SmartFile.FileSearch("하드 디스크", m_strSearchWord, chkSubDir.Checked);
                    for (int i = 0; i < m_sFoundFileList.Length; i++)
                    {
                        SmartListBoxAddItem(i);
                    }
                    m_sFoundFileList = SmartX.SmartFile.FileSearch("SD Card", m_strSearchWord, chkSubDir.Checked);
                    for (int i = 0; i < m_sFoundFileList.Length; i++)
                    {
                        SmartListBoxAddItem(i);
                    }
                    break;
                default:
                    break;
            }
        }

        private void SmartListBoxAddItem(int iIndex)
        {
            lstImageList.AddItem(m_sFoundFileList[iIndex].strPath + "\\" + m_sFoundFileList[iIndex].strFileName + "." + m_sFoundFileList[iIndex].strFileExtension);
        }
    }
}